//-----------------------------------------------------------------
//
//  RTF2BMP.DLL
//
//       (Notes On Current DLL Status)
//            - Compiled Using MS Visual C++ V5.0
//            - RE Control Does Not Support Right Handed Tabs!!!
//            - RE Control Does Not Support Pagination
//            - Selection Of Default Printer Affects BMP Output
//                Group3 Fax Is 1728 x 2200 Pixels
//                Epson24 Pin Is 1536 x 1980...Close Enough!!!
//                Winfax Pro Printer Driver Works Great also!!!
//                Otherwise, Write A Printer Driver...Yikes!!!
//            - Pages Are Formatted For BMP Output For 8.5" x 11"
//
//       (Notes On Exported Interface Functions)
//            - RTInitRtf2Bmp() Must Be Used To Initialize
//            - RTCloseRtf2Bmp() Must Be Used To Shut Down
//            - Use RTLoadRtfFile() To Load RTF File...Blocking
//            - Use RTConvertRtf2Bmp() To Convert File...Blocking
//            - Use RTSetPageTerm() To Set Page Termination String
//
//-----------------------------------------------------------------
#define STRICT

#include <stdlib.h>
#include <windows.h> 
#include <commctrl.h>           // Common Control Header
#include <richedit.h>           // RE Control Header

#include "resource.h"

//-----------------------------------------------------------------
// Exposed Interface Functions
BOOL WINAPI RTSetPageTerm(char *, int);
BOOL WINAPI RTInitRtf2Bmp(BOOL);
BOOL WINAPI RTCloseRtf2Bmp(VOID);
BOOL WINAPI RTLoadRtfFile(char *);
BOOL WINAPI RTConvertRtf2Bmp(VOID);

//-----------------------------------------------------------------
// Prototypes 
BOOL WINAPI    DllMain(HINSTANCE,DWORD,LPVOID);
BOOL           RTResetRtf2Bmp(BOOL);
BOOL           Rtf2BmpConvert(HWND,char *);
LONG           Rtf2BmpFindPrintTo(HWND,LONG,LONG,int,int,char *);
VOID           CreateBitmapFile(char *,BITMAPINFOHEADER *,char *);
DWORD          Rtf2BmpMain(LPDWORD);
LONG APIENTRY  MainWndProc(HWND,UINT,UINT,LONG);
BOOL APIENTRY  About(HWND,UINT,UINT,LONG);
BOOL           InitApplication(HANDLE);
BOOL           InitInstance(HANDLE,int);
HWND           InitToolbar(HWND);
DWORD CALLBACK EditStreamCallback(DWORD,LPBYTE,LONG,LONG FAR *);
BOOL           OpenRtfFile(HWND, char *);
VOID           FillFileDlgStruct(OPENFILENAME *, char *, char *, 
                                 char *, char *, DWORD);

//-----------------------------------------------------------------
// Miscellaneous Definitions
#define FAX_WIDTH_2432    2432   // Allowable Fax Image Widths
#define FAX_WIDTH_2048    2048
#define FAX_WIDTH_1728    1728

#define MAX_TERM_TEXT     128    // Max Size Of Termination Text

#define FMT_PAGE_RIGHT    8.500  // Inches Width 
#define FMT_PAGE_BOTTOM   11.500 // Inches Height
#define FMT_TWIP_INCH     1440   // 1440 TWIPS = 1 Inch
  
#define RTF_PRINT_NONE    0
#define RTF_PRINT_PAGE    1      // Print To Next Page Boundary
#define RTF_PRINT_TOTEXT  2      // Print To Defined Text

//-----------------------------------------------------------------
// Miscellaneous Globals
int            nNumberPages = 0;
int            nPageTermOffset = 0;
PRINTDLG       pd = {0};

HINSTANCE      hDLLInst = NULL;
HANDLE         hThreadApp = NULL;
BOOL           bShowRTFWnd = FALSE;
long           lRTReady = 0;

char           szPageTermText[MAX_TERM_TEXT];
char           szFileName[MAX_PATH];

//-----------------------------------------------------------------
// Handles
HANDLE         hRTFLib = NULL;
HWND           hWndToolbar = NULL;
HWND           hWndRichEdit = NULL;
HWND           hWndMain = NULL;

//-----------------------------------------------------------------
// Toolbar Buttons
TBBUTTON tbButtons[] = {
  { 0, 0,               TBSTATE_ENABLED, TBSTYLE_SEP,    0L, 0},
  { 0, 0,               TBSTATE_ENABLED, TBSTYLE_SEP,    0L, 0},
  { 0, 0,               TBSTATE_ENABLED, TBSTYLE_SEP,    0L, 0},
  { 0, IDM_BOLD,        TBSTATE_ENABLED, TBSTYLE_BUTTON, 0L, 0},
  { 1, IDM_ITALIC,      TBSTATE_ENABLED, TBSTYLE_BUTTON, 0L, 0},
  { 2, IDM_UNDERLINE,   TBSTATE_ENABLED, TBSTYLE_BUTTON, 0L, 0},
  { 0, 0,               TBSTATE_ENABLED, TBSTYLE_SEP,    0L, 0},
  { 3, IDM_ALIGNLEFT,   TBSTATE_ENABLED, TBSTYLE_BUTTON, 0L, 0},
  { 4, IDM_ALIGNCENTER, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0L, 0},
  { 5, IDM_ALIGNRIGHT,  TBSTATE_ENABLED, TBSTYLE_BUTTON, 0L, 0},
  };

//-----------------------------------------------------------------
//  DLL Entry Point
BOOL WINAPI DllMain(HINSTANCE hInst,DWORD  dwFunction,LPVOID lpNot)
{
    switch (dwFunction)
        {
        // Store The EXE Instance For Later Use By This DLL
        case DLL_PROCESS_ATTACH:  hDLLInst = hInst; break;
        case DLL_THREAD_ATTACH:                     break;
        case DLL_PROCESS_DETACH:                    break;
        case DLL_THREAD_DETACH:                     break;
        }

    return TRUE;
}

//-----------------------------------------------------------------
//  Main Loop...Called During RTF2BMP Initialization
DWORD Rtf2BmpMain(LPDWORD lpdwParam)
{
MSG   msg;

    // If Window Already Exists...Don't Recreate It...
    if (hWndMain == NULL)
        {
        // Load Common Control and RTF DLLs
        InitCommonControls();
        hRTFLib = LoadLibrary("RICHED32.DLL");
        if (!hRTFLib) return 0;
    
        if (!InitApplication(hDLLInst))       return 0;     
        if (!InitInstance(hDLLInst, SW_SHOW)) return 0;
        }

    // Main Message Loop...
    while(GetMessage(&msg, NULL, 0, 0))
        {
        if (IsDialogMessage(hWndMain, &msg)) continue;
  
        if(!TranslateAccelerator(hWndMain, NULL, &msg))
          {
          TranslateMessage(&msg);
          DispatchMessage(&msg);
          }
        }

    return msg.wParam;
}

//-----------------------------------------------------------------
// InitApplication
BOOL InitApplication(HANDLE hInstance)    
{
WNDCLASS  wcRichEdit;
HICON     hIcon;

    hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(RTF2BMP_ICON));

    wcRichEdit.style         = 0;
    wcRichEdit.lpfnWndProc   = (WNDPROC) MainWndProc; 
    wcRichEdit.cbClsExtra    = 0;
    wcRichEdit.cbWndExtra    = 0;
    wcRichEdit.hInstance     = hInstance;
    wcRichEdit.hIcon         = hIcon;
    wcRichEdit.hCursor       = LoadCursor(NULL, IDC_ARROW);
    wcRichEdit.hbrBackground = GetStockObject(WHITE_BRUSH);
    wcRichEdit.lpszMenuName  = "RichEdMenu";
    wcRichEdit.lpszClassName = "RichEdWClass";

    if (RegisterClass(&wcRichEdit) == FALSE) return FALSE;
    
    return TRUE;
}

//-----------------------------------------------------------------
// InitInstance
BOOL InitInstance(HANDLE hInstance, int nCmdShow) 
{
HWND    hWnd;

    // Create The RTF Window
    hWnd = CreateWindow("RichEdWClass", "RTF2BMPConv", 
                        WS_OVERLAPPEDWINDOW,
                        CW_USEDEFAULT, CW_USEDEFAULT, 
                        CW_USEDEFAULT, CW_USEDEFAULT,
                        NULL, NULL, hInstance, NULL);
    if (!hWnd) return FALSE;

    // Are We In Stealth Mode???
    if (bShowRTFWnd)
        {
        ShowWindow(hWnd, nCmdShow);
        UpdateWindow(hWnd); 
        }

    return TRUE;
}

//-----------------------------------------------------------------
// MainWndProc...Processes messages for main window
LONG APIENTRY MainWndProc(HWND hWnd, UINT message,
                          UINT wParam, LONG lParam)
{
LONG  lRC;
RECT  rcl;

    switch (message) 
        {
        case WM_CREATE:
            // Store The Handle To The Main Window
            hWndMain = hWnd;
            // Create The Toolbar
            hWndToolbar = InitToolbar(hWnd);

            // Initialize The RE Window For RTF2BMP Conversion
            if (RTResetRtf2Bmp(TRUE))
                {
                // If RTF Control Successfully Created, 
                // Initialize Setup PRINTDLG Structure And Get DC
                memset(&pd, 0, sizeof(PRINTDLG));
                pd.lStructSize = sizeof(PRINTDLG);
                pd.hwndOwner   = hWndMain;
                pd.hInstance   = (HANDLE) hDLLInst;
                pd.Flags       = PD_RETURNDC | PD_RETURNDEFAULT;
                PrintDlg(&pd);

                // Let Creating Thread Know Where Ready
                InterlockedExchange(&lRTReady, 1);
                }
            else
                {
                MessageBox(NULL, 
                           "ERROR: Creating RT Edit Control",
                           "RTF2BMP", MB_ICONEXCLAMATION | MB_OK);
                }
        
            break;

        case WM_SIZE:
            // Tell Toolbar To Resize Itself To Fill Top Of Window
            // Size RT Edit To Fit In Client Area Below Toolbar
            SendMessage(hWndToolbar, TB_AUTOSIZE, 0L, 0L);
            GetWindowRect(hWndToolbar, &rcl);
            MoveWindow(hWndRichEdit, 0, rcl.bottom - rcl.top, 
                       LOWORD(lParam), HIWORD(lParam), TRUE );
            break;
    
        case WM_COMMAND:
            switch (LOWORD(wParam))
                {
                case IDM_OPENRTF:
                    {
                    char         szPath[MAX_PATH];
                    OPENFILENAME ofOpenFile;
                    static char  szFilter[] = { 
                                              "RTF File (*.rtf)\0"
                                              "*.rtf\0"
                                              "\0"    
                                              };
                    
                    // Fill the File Open Dialog Box Structure
                    szPath[0] = '\0';
                    FillFileDlgStruct(&ofOpenFile, "rtf", szFilter,
                           "Select RTF File To Open", szPath,
                           OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST | 
                           OFN_NOCHANGEDIR);
                    
                    // Open File Open Dialog Box To Select RTF File
                    GetOpenFileName(&ofOpenFile);
                    lstrcpy(szFileName, szPath);
                    if (!OpenRtfFile(hWndRichEdit, szFileName))
                        MessageBox(hWnd, "ERROR: Open Failed!",
                                   "RTF2BMP", MB_OK);
                    }
                break;
      
                case IDM_TIFFCVT:
                    RTConvertRtf2Bmp();
                    break;
      
                case IDM_EXIT:
                    SendMessage (hWnd, WM_CLOSE, 0, 0L);
                    break;
      
                default:
                  lRC = DefWindowProc(hWnd,message,wParam,lParam);
                  return lRC;
                }
            break;

        case WM_DESTROY:
            // Free Up Resources
            if (pd.hDC)       DeleteDC(pd.hDC);
            if (hWndRichEdit) DestroyWindow(hWndRichEdit);
            if (hWndToolbar)  DestroyWindow(hWndToolbar);
    
            if (hRTFLib) 
                { 
                FreeLibrary(hRTFLib); 
                hRTFLib = NULL; 
                }
    
            PostQuitMessage(0);
            InterlockedExchange(&lRTReady, 0);
            break;
    
        default:
            lRC = DefWindowProc(hWnd,message,wParam,lParam);
            return lRC;
        }

    return FALSE;
}

//-----------------------------------------------------------------
// InitToolbar...Creates toolbar
HWND InitToolbar(HWND hWndParent)
{
HWND  hWndToolbar;

    // Create the toolbar control
    hWndToolbar = CreateToolbarEx( 
                    hWndParent,             // Parent Window
                    WS_CHILD | WS_BORDER | WS_VISIBLE | 
                    TBSTYLE_TOOLTIPS,       // Toolbar Window Style
                    IDB_TOOLBAR,            // Toolbar ID
                    6,                      // Number of Bitmaps
                    hDLLInst,               // Module Instance
                    IDB_TOOLBAR,            // Bitmap Resource ID
                    (LPCTBBUTTON)&tbButtons,// Address of Buttons
                    10,                     // Number of Buttons
                    16,16,                  // Button Width, Height
                    16,16,                  // Bitmap Width, Height
                    sizeof(TBBUTTON));      // Toobar Struct Size

    return hWndToolbar;
}

//-----------------------------------------------------------------
// OpenRtfFile...Opens RTF File And Streams Data Into RTF Control
BOOL OpenRtfFile(HWND hWndRE, char *lpszFileName)
{
HFILE       hFile;
OFSTRUCT    of;
EDITSTREAM  eStream;
long        lResult;
int         iAttrib = SF_RTF;

    hFile = OpenFile(lpszFileName, &of, OF_READ);
    if (hFile != HFILE_ERROR)
        {
        // dwCookie Is An App-Defined Value Holding The File Handle
        eStream.dwCookie    = hFile;
        eStream.dwError     = 0;
        eStream.pfnCallback = EditStreamCallback;
        lResult = SendMessage(hWndRE, EM_STREAMIN, 
                              (WPARAM) iAttrib, (LPARAM) &eStream);
        
        // Reset the dirty bit, Cleanup Handle, And Return
        SendMessage(hWndRE, EM_SETMODIFY, (WPARAM) TRUE, 0L);
        CloseHandle((HANDLE) hFile);
        return TRUE;
        }
    
    return FALSE;
}

//-----------------------------------------------------------------
// EditStreamCallback...Callback That Reads In RTF Edit Stream.
DWORD CALLBACK EditStreamCallback(DWORD dwCookie, LPBYTE pbBuff, 
                                  LONG lBytes, LONG FAR *pBytes)
{
HANDLE hHandle;
    
    hHandle = (HANDLE) dwCookie;
    if (!(ReadFile(hHandle, pbBuff, lBytes, pBytes, NULL)))
        return (GetLastError());

    return 0;
}

//-----------------------------------------------------------------
// Fill The File Struct With Params
VOID FillFileDlgStruct(OPENFILENAME *ofFile, char *szExt, 
                       char *szOpenFileFilter, 
                       char *szTitle, char *szOpenFilePath, 
                       DWORD dwFlags)
{
OPENFILENAME    *ofOpenFile;

    ofOpenFile = ofFile;
    memset(ofOpenFile, 0, sizeof(OPENFILENAME)); 

    ofOpenFile->lStructSize = sizeof(OPENFILENAME);
    ofOpenFile->lpstrFilter = szOpenFileFilter;
    ofOpenFile->lpstrFile   = szOpenFilePath;
    ofOpenFile->nMaxFile    = 256;
    ofOpenFile->lpstrTitle  = szTitle;
    ofOpenFile->Flags       = dwFlags;
    ofOpenFile->lpstrDefExt = szExt;
}

//-----------------------------------------------------------------
//  Initialize The Rtf2Bmp Converter
BOOL WINAPI RTInitRtf2Bmp(BOOL bShowWnd) 
{
DWORD   dwArgParam = 0, dwIDApp = 0;
int     i, nMaxWaitCnt = 10;

    // Initialize The Global Page Termination Check String
    lstrcpy(szPageTermText, "Page");
    nPageTermOffset = 12;

    // Fix The Total Page Count Of Any RTF File To 10
    nNumberPages = 10;
      
    // Create Main App Thread For Window Display And Message Loop
    // Don't Recreate This Thread If It Is Already Running...
    if (hThreadApp == NULL)
        {
        bShowRTFWnd = bShowWnd;

        dwArgParam = 1;
          hThreadApp = CreateThread(NULL, // No Security Attributes
                           0,             // Use Default Stack Size
                                          // Thread Function
                           (LPTHREAD_START_ROUTINE) Rtf2BmpMain,
                           &dwArgParam,   // Thread Function Arg
                           0,             // Default Creation Flags
                           &dwIDApp);     // Returns Thread ID
        if (hThreadApp == NULL) return FALSE;
        }
  
    // Wait Here For A While, Until The RTF Thread Is Ready
    for (i=0; i < nMaxWaitCnt; i++)
        {
        Sleep(500);
        if (lRTReady > 0) return TRUE;
        }

    return FALSE;
}

//-----------------------------------------------------------------
//  Close The Rtf2Bmp Converter
BOOL WINAPI RTCloseRtf2Bmp(VOID) 
{
int     nCnt, nMaxWait = 10;
DWORD   dwExitCode;

    // Close Up The RTF Main Window
    SendMessage(hWndMain, WM_DESTROY, 0, 0);

    // Wait A Short While For The Run Event Thread To Terminate
    for (nCnt=0; nCnt < nMaxWait; nCnt++)
        {
        Sleep(500);
        GetExitCodeThread(hThreadApp, &dwExitCode);
        if (dwExitCode != STILL_ACTIVE) break;

        // Kill The Thread Because We Don't Want To Wait Anymore
        if (nCnt == nMaxWait) TerminateThread(hThreadApp, 0);
        }

    CloseHandle((HANDLE) hThreadApp);
    return TRUE;
}

//-----------------------------------------------------------------
//  Load The Specified RTF File Into Rich Edit Control
BOOL WINAPI RTLoadRtfFile(char *szFile) 
{
    // Verify That The Window Has Already Been Opened
    if (hWndRichEdit == NULL) return FALSE;

    // Open The RTF File And Load It Into The RTF Control
    lstrcpy(szFileName, szFile);
    if (!OpenRtfFile(hWndRichEdit, szFileName)) return FALSE;

    return TRUE;
}

//-----------------------------------------------------------------
//  Convert The Text In The RE Control To Bmp Format
BOOL WINAPI RTConvertRtf2Bmp(VOID) 
{
    // Verify That The Window Has Already Been Opened
    if (hWndRichEdit == NULL) return FALSE;

    // Convert The RTF File To BMP
    if (!Rtf2BmpConvert(hWndRichEdit, szFileName)) return FALSE;

    // Reset Converter For Next Conversion
    RTResetRtf2Bmp(FALSE);
    return TRUE;
}

//-----------------------------------------------------------------
//  Set The Page Termination Data To Help With Pagination
BOOL WINAPI RTSetPageTerm(char *szText, int nOffSet) 
{
    // Limit Termination String Length
    if (lstrlen(szText) >= MAX_TERM_TEXT) return FALSE;

    // Store Termination String In Global Check String
    lstrcpy(szPageTermText, szText);
    nPageTermOffset = nOffSet;
    return TRUE;
}

//-----------------------------------------------------------------
//  Reset The Rtf2Bmp Converter
BOOL RTResetRtf2Bmp(BOOL bStartup) 
{
RECT    rcl1, rcl2;
HWND    hWndRE;

    if (hWndRichEdit != NULL) 
        {
        if (!DestroyWindow(hWndRichEdit)) return FALSE;
        }

    // Create RTF Control.            
    hWndRE = CreateWindowEx(
        WS_EX_CLIENTEDGE,    // Make RTF Control Appear "Sunken"
        "RICHEDIT",          // Class Name of RTF Control
        "",                  // Text Placed Into RTF Control
        WS_CHILD | WS_VISIBLE | WS_HSCROLL | WS_VSCROLL |
        ES_MULTILINE | ES_SAVESEL,
        0, 0, 0, 0,          // Main Wnd's WM_SIZE Will Resize
        hWndMain,            // Use Main Parent
        (HMENU) ID_RICHED,   // Menu ID 
        hDLLInst,            // This App Instance Owns This Window
        NULL);               // Pointer To Window Creation Data

    // Store Handle And Validate RTF Window Creation
    hWndRichEdit = hWndRE;
    if (hWndRichEdit == NULL) return FALSE;

    // Set Focus To RTF Control.
    SetFocus(hWndRichEdit);

    // This Is Handled In The WM_SIZE Message On Startup
    if (!bStartup)
        {
        // Get The Size Of The Toolbar And
        // Size RTF Control To Fit In Client Area Below Toolbar
        GetWindowRect(hWndToolbar, &rcl1);
        GetWindowRect(hWndMain, &rcl2);
        MoveWindow(hWndRichEdit, 
                   0, rcl1.bottom - rcl1.top, 
                   rcl2.right, rcl2.bottom, TRUE);
        }
    return TRUE;
}

//-----------------------------------------------------------------
// Rtf2BmpConvert...Prints Contents Of RT Edit Control To Bmp File
BOOL Rtf2BmpConvert(HWND hWndRE, char *szConvFile)
{
FORMATRANGE       fr;
HDC               hDstDC  = NULL;
HBITMAP           hOldBmp = NULL, hBmp = NULL;
RGBQUAD           *pRGB   = NULL;
BITMAPINFOHEADER  *pBMPH  = NULL;

float             fHRatio, fVRatio;
long              lTextMin = 0, lTextMax = 0;
long              lTextPrinted = 0, lTextLength = 0;
int               nPageNumber = 0;
int               nPrinterHRes = 0, nPrinterVRes = 0;
int               nCU = 2, nBMPISize = 0;
int               nWidth, nHeight, nByteWidth;
int               nTotalBufferSize = 0;
char              *pBuffer = NULL;
char              *pBMPI = NULL;

    // Get the printer DC Horizontal And Vertical Res
    nPrinterHRes = GetDeviceCaps(pd.hDC, HORZRES);
    nPrinterVRes = GetDeviceCaps(pd.hDC, VERTRES);
  
    // Set To The Group 3 Fax Fixed Width And Height, 
    // Then Set The Group 3 Fax To Printer DC Ratios For Later Use
    nWidth  = FAX_WIDTH_1728;
    nHeight = (int) ((FMT_PAGE_BOTTOM / FMT_PAGE_RIGHT) * 
                     (float) nWidth);
    fHRatio = (float) nWidth  / (float) nPrinterHRes;
    fVRatio = (float) nHeight / (float) nPrinterVRes;

    // Allocate Enough Memory For The Whole Image
    nByteWidth       = nWidth / 8;
    nTotalBufferSize = nByteWidth * nHeight;
    pBuffer = malloc(nTotalBufferSize);
    if (pBuffer == NULL) return FALSE;

    // Create BITMAPINFO Struct
    // Color Table Goes At The End Of The BITMAPINFOHEADER Struct
    nBMPISize = (sizeof (BITMAPINFOHEADER)) + 
                (nCU * sizeof(RGBQUAD));
    pBMPI     = malloc(nBMPISize);
    if (pBMPI == NULL) { free(pBuffer); return FALSE; }

    // Fill The BITMAPINFOHEADER Struct For Mono Bitmap
    memset(pBMPI, 0, nBMPISize);
    pBMPH = (BITMAPINFOHEADER *) pBMPI;
    pBMPH->biSize        = sizeof (BITMAPINFOHEADER);
    pBMPH->biPlanes      = 1; 
    pBMPH->biBitCount    = 1; 
    pBMPH->biCompression = BI_RGB; 
    pBMPH->biSizeImage   = nTotalBufferSize; 
    pBMPH->biClrUsed     = 1 << pBMPH->biBitCount; 
    pBMPH->biWidth       = nWidth; 
    pBMPH->biHeight      = 0-nHeight; 

    // Set The Colors To White And Black
    pRGB = (RGBQUAD *) (pBMPI + sizeof (BITMAPINFOHEADER));
    pRGB->rgbBlue = pRGB->rgbRed = pRGB->rgbGreen = (BYTE) 0x00;
    pRGB++;
    pRGB->rgbBlue = pRGB->rgbRed = pRGB->rgbGreen = (BYTE) 0xFF;

    // Create A Compatible Memory DC From The Printer DC
    hDstDC = CreateCompatibleDC(pd.hDC);
 
    // Fill out the FORMATRANGE structure for the RTF output.
    fr.hdc       = hDstDC;
    fr.hdcTarget = pd.hDC;
    fr.rc.top    = FMT_TWIP_INCH / 4;   // Quarter Inch Top Margin
    fr.rc.left   = FMT_TWIP_INCH / 2;   // Half Inch Left Margin
    fr.rc.right  = 
          (int) ((FMT_PAGE_RIGHT  * FMT_TWIP_INCH) * fHRatio) - 
                 (FMT_TWIP_INCH / 2);   // Half Inch Bottom Margin
    fr.rc.bottom = 
          (int) ((FMT_PAGE_BOTTOM * FMT_TWIP_INCH) * fVRatio) - 
                 (FMT_TWIP_INCH / 2);   // Half Inch Right Margin
    fr.rcPage.top    = 0;
    fr.rcPage.left   = 0;
    fr.rcPage.right  = 
              (int) ((FMT_PAGE_RIGHT  * FMT_TWIP_INCH) * fHRatio);
    fr.rcPage.bottom = 
              (int) ((FMT_PAGE_BOTTOM * FMT_TWIP_INCH) * fVRatio);

    // Set The Mapping Mode Of The Printer And Memory DCs To Text
    SetMapMode(hDstDC, MM_TEXT);
    SetMapMode(pd.hDC, MM_TEXT);
  
    // Create A Device Dependent Bitmap
    hBmp = CreateDIBitmap(hDstDC,         // DC Handle 
                        pBMPH,            // BMP Format Data Ptr
                        0,                // Flags 
                        NULL,             // Data Ptr - None
                        NULL,             // BMP Color-Fmt Data Ptr
                        DIB_RGB_COLORS);  // color-data usage 

    // Set Target Device To Default Printer
    SendMessage(hWndRE, EM_SETTARGETDEVICE, (WPARAM) (HDC) pd.hDC, 
                (LPARAM) fr.rcPage.right);

    // Determine How Many Characters There Are In The RTF Control, 
    // Then Loop Through The Complete Document
    lTextLength = SendMessage(hWndRE, WM_GETTEXTLENGTH, 0, 0);
    do
        {
        // Set Printed Bitmap To Clear Out Background For Next Page
        memset(pBuffer, 0xFF, nTotalBufferSize);

        // Set Pixels In Bitmap Using Color Data Found In DIB. 
        SetDIBits(hDstDC,           // Compatible DC Created
              hBmp,                 // Bitmap Handle
              0,                    // Dest Bitmap First Scan Line
              nHeight,              // Nbr Of Scan Lines To Copy 
              pBuffer,              // Bitmap Bits Array Address
              (LPBITMAPINFO) pBMPI, // Bitmap Data Struct Address  
              DIB_RGB_COLORS);      // RGB Or Palette Index 

        // Select Bitmap Into The Destination DC For Printing
        hOldBmp = SelectObject(hDstDC, hBmp);

        // Find Where To Print To, Which Is Up To The Page Marker
        lTextMax = Rtf2BmpFindPrintTo(hWndRE, lTextMax, 
                                  -1, RTF_PRINT_TOTEXT, 
                                  nPageTermOffset, szPageTermText);
    
        // Print Contents As Defined By The Character Boundaries
        // If Page Marker Was Defined, Print Whatever Fits On Page
        fr.chrg.cpMin = lTextMin;
        fr.chrg.cpMax = lTextMax;
        lTextPrinted = SendMessage(hWndRE, EM_FORMATRANGE, 
                                   TRUE, (LPARAM) &fr);

        // If Page Marker Found, Then Add Image To BMP File...
        // At Least Create Single Blank Image When There Is No Text
        // Add Some Of Characters On The End (+2)...Fudge Factor
        if (nPageNumber == 0 || lTextPrinted <= lTextLength+2)
            {
            // This Is The New Starting Point For The Next Page
            lTextMin = lTextPrinted;

            // GDI Doc Claims...
            // Do Not Have Bitmap Selected During GetDIBits()
            hBmp = SelectObject(hDstDC, hOldBmp);
  
            // Get Printed Bitmap And Place Data Into pBuffer
            GetDIBits(hDstDC,         // Compatible DC Created
                hBmp,                 // Bitmap Handle
                0,                    // Dest BMP First Scan Line
                nHeight,              // Nbr Of Scan Lines To Copy  
                pBuffer,              // Bitmap Bits Array Address  
                (LPBITMAPINFO) pBMPI, // Bitmap Data Struct Address 
                DIB_RGB_COLORS);      // RGB Or Palette Index       
 
            // Open The Output BMP File
            CreateBitmapFile(szConvFile, pBMPH, pBuffer); 
            nPageNumber++;
            }
        // Otherwise, We Are At The End Of The Document
        else
            {
            // Reset Formatting Of RE Control At End Of Document
            LPARAM lParam = (LPARAM) NULL;
            SendMessage(hWndRE, EM_FORMATRANGE, TRUE, lParam);
            }

        // Terminate On Max Pages Or At The End Of The RE Text
        } while (nPageNumber  < nNumberPages && 
                 lTextPrinted < lTextLength);

    // Clean Up DCs And Bitmaps
    if (hDstDC != NULL) DeleteDC(hDstDC);
    if (hBmp   != NULL) DeleteObject(hBmp);

    // Free Up The Allocated Buffers
    if (pBuffer != NULL) free(pBuffer);
    if (pBMPI   != NULL) free(pBMPI);

    return TRUE;
}

//-----------------------------------------------------------------
// Rtf2BmpFindPrintTo...Finds Where To Print To In RTF File
LONG Rtf2BmpFindPrintTo(HWND hWndRE, LONG cpMin, LONG cpMax, 
                        int nMode, int nOffSet, char *szText)
{
FINDTEXT    ftText;
LONG        lTextMark = -1;

    switch (nMode)
        {
        // Print To Text Phrase Passed In The szText Argument
        case RTF_PRINT_TOTEXT:
            if (lstrlen(szText) > 0)
                {
                // Set The Text Marker In The RTF File
                ftText.lpstrText  = szText;
                ftText.chrg.cpMin = cpMin;
                ftText.chrg.cpMax = cpMax;

                // Look For The Page Marker In The RTF Document
                lTextMark = SendMessage(hWndRE, EM_FINDTEXT, 0, 
                                    (LPARAM) (FINDTEXT *) &ftText);

                // Apply Offset, Only If We Have Not 
                // Reached The End Of The RTF Text
                if (lTextMark != -1) lTextMark += nOffSet;
                }
            break;

        // Print To Next Page Boundary
        case RTF_PRINT_PAGE:
            break;

        default:
            break;
        }

    return lTextMark;
}

//-----------------------------------------------------------------
//  CreateBitmapFile()  Create Raw Bitmap File From Buffer
VOID CreateBitmapFile(char *szConvFile, BITMAPINFOHEADER *pBMPH, 
                      char *pBuffer)
{
HANDLE    fh1;
DWORD     dwTmp;
char      *pLoc = NULL, szTmpName[MAX_PATH];

    // Set Output File Name XXXXXX.rtf --> XXXXXX.r2b
    lstrcpy(szTmpName, szConvFile);
    pLoc = strstr(szTmpName, ".rtf");
    if (pLoc != NULL) *pLoc = 0;
    lstrcat(szTmpName, ".r2b");

    // Write Raw Data To File
    fh1 = CreateFile(szTmpName, GENERIC_READ | GENERIC_WRITE, 
                   (DWORD) 0, (LPSECURITY_ATTRIBUTES) NULL, 
                   CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 
                   (HANDLE) NULL);  
    WriteFile(fh1, (LPVOID) pBuffer, pBMPH->biSizeImage,
              (LPDWORD) &dwTmp, (LPOVERLAPPED) NULL);
    CloseHandle(fh1);
}
