//------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "About.h"
//------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TdlgAbout *dlgAbout;
//------------------------------------------------------------------
__fastcall TdlgAbout::TdlgAbout(TComponent* Owner)
: TdlgAbout_PARENT(Owner)
{
}
//------------------------------------------------------------------
void __fastcall TdlgAbout::Initialize()
{
   OSVERSIONINFO verInfo;
   TCHAR tmp[0x1000];

   verInfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);

   if(GetVersionEx(&verInfo))
   {
      switch(verInfo.dwPlatformId)
      {
         case VER_PLATFORM_WIN32_WINDOWS: // Win95 & Win98
            switch(verInfo.dwMinorVersion)
            {
               case 0: // Win95
                  wsprintf(tmp, "Windows 95 %s",
                     verInfo.szCSDVersion);
                  break;

               case 10: // Win98
                  wsprintf(tmp, "Windows 98 %s",
                     verInfo.szCSDVersion);
                  break;

               default:
                  break;
            }
            break;

         case VER_PLATFORM_WIN32_NT:
            wsprintf(tmp, "Windows NT %d.%d %s (Build %d)",
               verInfo.dwMajorVersion,
               verInfo.dwMinorVersion,
               verInfo.szCSDVersion,
               verInfo.dwBuildNumber);
            break;

         default:
            break;
      }
   }

   stOSString->Caption = AnsiString(tmp);

   MEMORYSTATUS memStatus;

   memStatus.dwLength = sizeof(MEMORYSTATUS);

   GlobalMemoryStatus(&memStatus);

   // Put a nice comma between the thousand units.
   stMemory->Caption =
      FormatMemory(memStatus.dwAvailPageFile / 1024) + " K";
}

////////////////////////////////////////////////////////////////////
// FormatMemory
//
// Turns a number into a neatly formatted string with "," for
// thousands. Really it should use the system separator!
//
// Params:
// int - memory value to be formatted
//
// Returns:
// AnsiString - formatted string
//
// Type:
// private
//
AnsiString __fastcall TdlgAbout::FormatMemory(int memory)
{
   AnsiString buffer = "";

   while(memory / 1000)
   {
      TCHAR tmp[0x100];

      wsprintf(tmp, "%03d,", memory / 1000);

      buffer += AnsiString(tmp);

      memory -= 1000 * (memory / 1000);
   }

   TCHAR tmp[0x100];

   wsprintf(tmp, "%03d", memory);

   buffer += AnsiString(tmp);

   return(buffer);
}
void __fastcall TdlgAbout::FormShow(TObject *Sender)
{
   Initialize();
}
//------------------------------------------------------------------
