//------------------------------------------------------------------
#ifndef ACTIVELABEL_H
#define ACTIVELABEL_H

#define TActiveLabel_PARENT TCustomControl

class TActiveLabel : public TActiveLabel_PARENT
{
public:
  __fastcall TActiveLabel(TComponent* owner);
  virtual __fastcall ~TActiveLabel();

protected:  // Overrides.
  virtual void __fastcall CreateParams(TCreateParams& params);
  virtual void __fastcall Paint();

private:    // Implementation.
  void __fastcall Shell(AnsiString cmd);
  void __fastcall CalculateBounds();
  bool __fastcall OnProcessSpecialCommand();
  void __fastcall OnExit();
  void __fastcall OnExplore();

private:    // Implementation.
  bool m_Tracking;    

protected:  // Windows message processing.
  void __fastcall OnMouseMove(TMessage& msg);
  void __fastcall OnMouseLeave(TMessage& msg);
  void __fastcall OnLButtonUp(TMessage& msg);

BEGIN_MESSAGE_MAP
  MESSAGE_HANDLER(WM_MOUSEMOVE, TMessage, OnMouseMove)
  MESSAGE_HANDLER(WM_MOUSELEAVE, TMessage, OnMouseLeave)
  MESSAGE_HANDLER(WM_LBUTTONUP, TMessage, OnLButtonUp)
END_MESSAGE_MAP(TActiveLabel_PARENT)

private:    // Data.
  AnsiString m_Caption;
  AnsiString m_Command;
  bool m_AutoSize;
  TColor m_ActiveColor;
  TColor m_InactiveColor;
  AnsiString m_EnterSound;
  AnsiString m_CommandSound;

private:    // Access methods.
  void __fastcall SetCommand(AnsiString command);
  void __fastcall SetAutoSize(bool autoSize);
  void __fastcall SetActiveColor(TColor color);
  void __fastcall SetInactiveColor(TColor color);
  void __fastcall SetCaption(AnsiString caption);
  void __fastcall SetEnterSound(AnsiString enterSound);
  void __fastcall SetCommandSound(AnsiString commandSound);


  // Interface
public:
  // Inherited properties.
  __property Left;
  __property Top;
  __property Width;
  __property Height;
  __property Font;

  // Local properties.
  __property AnsiString Caption =
     {read = m_Caption, write=SetCaption };
  __property AnsiString Command =
     { read=m_Command, write=SetCommand };
  __property bool AutoSize =
     { read=m_AutoSize, write=SetAutoSize };
  __property TColor ActiveColor =
     { read=m_ActiveColor, write=SetActiveColor };
  __property TColor InactiveColor =
     { read=m_InactiveColor, write=SetInactiveColor };
  __property AnsiString EnterSound =
     { read=m_EnterSound, write=SetEnterSound };
  __property AnsiString CommandSound =
     { read=m_CommandSound, write=SetCommandSound };
};

//------------------------------------------------------------------
#endif
