// glp1.cpp (UNICODE)

#include <stdio.h>
#include "LongPath.h"
#include <shlwapi.h>


bool getLongPathName1( LPCTSTR pszShort, LPTSTR pszLong ) {
    
    WCHAR *pwszDisplayName = 0;

#ifdef UNICODE
#define wszShort const_cast< LPWSTR >( pszShort )
#else
    WCHAR wszShort[ MAX_PATH ] = { 0 };
    MultiByteToWideChar( CP_ACP, 0, 
        pszShort, lstrlenA( pszShort), wszShort, MAX_PATH );
#endif

    IMoniker *pMoniker = 0;
    HRESULT hres = CreateFileMoniker( wszShort, &pMoniker );
    if ( SUCCEEDED( hres ) ) {

        IBindCtx *pBindCtx = 0;
        hres = CreateBindCtx( 0, &pBindCtx );
        if ( SUCCEEDED( hres ) ) {
            hres = pMoniker->GetDisplayName( 
                pBindCtx, 0, &pwszDisplayName );
            if ( !SUCCEEDED( hres ) ) {
                pwszDisplayName = 0;
            }
            pBindCtx->Release();
        }
        pMoniker->Release();
    }

    if ( 0 == pwszDisplayName ) {
        return false;
    }

#ifdef UNICODE
    // NOTE: lstrcpy fails with ERROR_CALL_NOT_IMPLEMENTED on Win95!
    wcscpy( pszLong, pwszDisplayName ); 
#else
    WideCharToMultiByte( CP_ACP, 0, 
        pwszDisplayName, lstrlenW( pwszDisplayName ), 
        pszLong, MAX_PATH, 0, 0 );
#endif

    IMalloc *pMalloc = 0;
    if ( SUCCEEDED( SHGetMalloc( &pMalloc ) ) ) {
        pMalloc->Free( pwszDisplayName );
        pMalloc->Release();
    }

    return true;
}

// end of file
