// glp2.cpp (UNICODE)

#include "LongPath.h"


bool getLongPathName2( LPCTSTR pszShort, LPTSTR pszLong ) {

    IShellFolder *pShellFolder = 0;
    HRESULT hres = SHGetDesktopFolder( &pShellFolder );
    if ( SUCCEEDED( hres ) ) {

#ifdef UNICODE
#define wszShort const_cast< LPWSTR >( pszShort )
#else
        WCHAR wszShort[ MAX_PATH ] = { 0 };
        MultiByteToWideChar( CP_ACP, 0, 
            pszShort, lstrlenA( pszShort ), wszShort, MAX_PATH );
#endif

        ULONG ulEaten = 0;
        ITEMIDLIST *pidl = 0;
        ULONG ulAttributes = 0;
        hres = pShellFolder->ParseDisplayName( HWND_DESKTOP, 0,
            const_cast< LPWSTR >( wszShort ), 
            &ulEaten, &pidl, &ulAttributes );
        if ( SUCCEEDED( hres ) ) {
            STRRET strRet = { STRRET_CSTR };
            hres = pShellFolder->GetDisplayNameOf( 
                pidl, 0, &strRet );
            if ( SUCCEEDED( hres ) ) {
                if ( STRRET_WSTR == strRet.uType ) {
#ifdef UNICODE
                    // Fails on Win95, but that's OK, 
                    // since we don't get here anyhow.
                    lstrcpyW( pszLong, strRet.pOleStr );
#else
                    WideCharToMultiByte( CP_ACP, 0, 
                        strRet.pOleStr, lstrlenW( strRet.pOleStr ), 
                        pszLong, MAX_PATH, 0, 0 );
#endif
                    comFree( strRet.pOleStr );
                } else if ( STRRET_OFFSET == strRet.uType ) {
                    LPCSTR psz = (LPCSTR) pidl + strRet.uOffset;
#ifdef UNICODE
                    MultiByteToWideChar( CP_ACP, 0, 
                        psz, lstrlenA( psz ), pszLong, MAX_PATH );
#else
                    lstrcpyA( pszLong, psz );
#endif
                } else if ( STRRET_CSTR == strRet.uType ) {
#ifdef UNICODE
                    MultiByteToWideChar( CP_ACP, 0, 
                        strRet.cStr, lstrlenA( strRet.cStr ), pszLong, MAX_PATH );
#else
                    lstrcpyA( pszLong, strRet.cStr );
#endif
                }
            }

            comFree( pidl );
        }
        pShellFolder->Release();
    }

    return SUCCEEDED( hres );
}

// end of file
