// glp3.cpp (UNICODE)

#include "LongPath.h"


bool getLongPathName3( LPCTSTR pszShort, LPTSTR pszLong ) {

    IShellFolder *pShellFolder = 0;
    HRESULT hres = SHGetDesktopFolder( &pShellFolder );
    if ( SUCCEEDED( hres ) ) {

#ifdef UNICODE
#define wszShort const_cast< LPWSTR >( pszShort )
#else
        WCHAR wszShort[ MAX_PATH ] = { 0 };
        MultiByteToWideChar( CP_ACP, 0, 
            pszShort, lstrlenA( pszShort ), wszShort, MAX_PATH );
#endif

        ULONG ulEaten = 0;
        ITEMIDLIST *pidl = 0;
        ULONG ulAttributes = 0;
        hres = pShellFolder->ParseDisplayName( HWND_DESKTOP, 0,
            wszShort, &ulEaten, &pidl, &ulAttributes );
        if ( SUCCEEDED( hres ) ) {

#ifdef UNICODE
            char szLong[ MAX_PATH ] = { 0 };
            hres = SHGetPathFromIDListA( pidl, szLong );
            MultiByteToWideChar( CP_ACP, 0, 
                szLong, lstrlenA( szLong ), pszLong, MAX_PATH );
#else
            hres = SHGetPathFromIDList( pidl, pszLong );
#endif

            comFree( pidl );
        }
        pShellFolder->Release();
    }

    return SUCCEEDED( hres );
}

// end of file
